<template>
  <div class="game-round">
    <div class="game-container">
      <p v-if="loadingMessage">{{ loadingMessage }}</p>
      <p v-if="error">{{ error }}</p>

      <main v-if="deck">
        <div v-if="!result" class="player-actions">
          <button @click="drawCard">Hit</button>
          <button @click="onStopClicked">Stand</button>
        </div>

        <div class="results" v-if="result">
          <h2>{{ result }}</h2>
          <button @click="reset">Play again</button>
        </div>

        <div class="stats">
          <p>Remaining: {{ deck.remaining }}</p>
        </div>

        <div class="cards">
          <div class="deck dealer">
            <h4>Dealer - {{ dealerScore }}</h4>
            <div class="dealer-cards">
              <GameCard v-bind:card-image="card.image" v-for="card of dealerCards" :key="card.value + card.suit"/>
            </div>
          </div>
          <div class="deck player">
            <h4>Player - {{ playerScore }}</h4>
            <div class="player-cards">
              <GameCard v-bind:card-image="card.image" v-for="card of playerCards" :key="card.value + card.suit"/>
            </div>
            <br>
            <button v-if="canToggleAce" @click="onToggleAceClicked">Toggle Ace Value</button>
          </div>
        </div>

      </main>

    </div>

  </div>
</template>

<script>
import {getDeck} from "@/api/card.api";
import {calculateHand, hasAce, isBust} from "@/utils/card.util";
import GameCard from "@/components/GameCard";
import Deck from '@/models/deck';

export default {
  name: 'GameRound',
  components: {GameCard},
  async created() {
    await this.initGame();
  },
  data() {
    return {
      loadingMessage: 'Getting deck...',
      error: '',
      playerCards: [],
      playerScore: 0,
      canToggleAce: false,
      dealerCards: [],
      dealerScore: 0,
      deck: null,
      result: ''
    }
  },
  methods: {
    async initGame() {
      try {
        const {deck_id, remaining} = await getDeck();
        this.deck = new Deck(deck_id, remaining);
      } catch (e) {
        this.error = e.message;
      } finally {
        this.loadingMessage = '';
      }
    },
    async drawCard() {
      this.loadingMessage = 'Drawing a card...';
      try {
        const {cards, remaining} = await this.deck.drawCards();
        this.deck.remaining = remaining;
        this.playerCards.push(...cards);
        this.playerScore = calculateHand(this.playerCards);
        this.canToggleAce = hasAce(this.playerCards);
        if (isBust(this.playerScore)) {
          this.result = 'Bye bye money! 💸';
        }
      } catch (e) {
        this.error = e.message;
      } finally {
        this.loadingMessage = '';
      }
    },
    onToggleAceClicked() {
      this.playerScore = calculateHand(this.playerCards, true);
    },
    reset() {
      this.playerScore = 0;
      this.playerCards = [];
      this.canToggleAce = false;
      this.dealerScore = 0;
      this.dealerCards = [];
      this.deck = null;
      this.result = '';
      this.loadingMessage = 'Getting a new deck...';
      this.initGame();
    },
    async onStopClicked() {
      // Recursively call for dealer until >= 19.
      const drawDealerCard = async () => {
        const {cards, remaining} = await this.deck.drawCards();
        this.deck.remaining = remaining;
        this.dealerCards.push(...cards);
        this.dealerScore = calculateHand(this.dealerCards);

        if (this.dealerScore < 19) {
          await drawDealerCard();
        }
      }

      await drawDealerCard();

      if (isBust(this.dealerScore)) {
        this.result = 'You win! Dealer Busts! 💥';
      } else {
        this.getWinner();
      }

    },
    getWinner() {

      if (this.playerScore === this.dealerScore) {
        // draw...
        this.result = "It's a draw!";
      } else if (this.playerScore > this.dealerScore) {
        // Player wins
        this.result = "Nooooice!! You win! 🎉 - Stonks!";
      } else {
        // Dealer wins
        this.result = "Dealer takes the 💰💰  -- OUCH!";
      }

    }
  }
}
</script>

<style scoped>
h4 {
  margin-bottom: 1em;
}

.player-cards, .dealer-cards {
  display: flex;
  flex-wrap: wrap;
}

.cards {
  display: grid;
  grid-template-columns: 1fr 1fr;
}

.deck {
  padding: 1em 0;
}
.deck.dealer {
  padding-right: 1em;
}

</style>